<template>
    <div class="todo">
        <div class="title" >Список заданий</div>

        <todo-form @new-todo="addTodo" @find="searchItem" :nextId="0" />

        <div class="filter ">
            <div class="tab" :class="{'active' : flag === 0}" @click="flag = 0">Все</div>
            <div class="tab" :class="{'active' : flag === true}" @click="flag = true">Завершенные</div>
            <div class="tab" :class="{'active' : flag === false}" @click="flag = false">Не выполненные</div>

        </div>
        <div class="list-items">
            <div v-if="listTask.length <= 0" class="empty">К сожалению ничего не найдено :(</div>
            <list-item v-else @delete-task="deleteTask" @update-list="update" v-for="(item,index) in searchResult" :key="index" :task="item"  />
        </div>

    </div>
</template>

<script>
    import todoForm from '@/components/todo/todoForm'
    import listItem from '@/components/todo/todoListItem'

    export default {
        name: "todo-index",

        components: {
            todoForm,
            listItem
        },
        props: {
           listTask: {
               type: Array
           }
        },
        data() {
            return {
                id: '',
                search: '',
                flag: 0,
            }
        },
        methods: {
            addTodo(todo) {
                this.listTask.push(todo);
                this.$emit('update-tasks');
            },
            deleteTask(item) {
                const taskIndex = this.listTask.indexOf(item);
                this.listTask.splice(taskIndex, 1);
                this.$emit('update-tasks');
            },
            searchItem(key) {
                this.search = key;
            },
            update() {
                this.$emit('update-tasks');
            }
        },
        computed: {
            filterState() {
                if (this.flag === 0) {
                    return this.listTask;
                } else {
                    return this.listTask.filter((item) => {
                        return item.done === this.flag
                    })
                }
            },
            searchResult() {
                return this.filterState.filter((item) => {
                    return item.name.toLowerCase().match(this.search.toLowerCase())
                })
            },
        },
        mounted() {

        }
    }
</script>

<style lang="scss" scoped>

    .filter {
        display: flex;

        .tab {
            padding: 10px 20px;
            border: 1px solid #cecece;
            border-top-left-radius: 5px;
            border-top-right-radius: 5px;
            cursor: pointer;

            &.active {
                background: #cb1a31;
                cursor: default;
                color: #fff;
            }
        }
    }

    .todo {
        border: 1px solid #cecece;
        padding: 20px 20px;
        background: #f1f1f1;
    }

    .title {
        font-size: 18px;
        font-weight: 600;
    }
    .list-items {
        width: 100%;
        background: #fff;
        box-shadow: 0 0 5px rgba(0,0,0,0.15);
        margin: 0 auto;

        .empty {
            text-align: center;
            font-size: 21px;
            font-style: italic;
            color: #5f5f5f;
            padding: 20px 0;
        }
    }

</style>